/// <reference types="node" />
import http = require('http');
declare type MethodType = 'GET' | 'POST';
declare type MimeType = 'text' | 'json' | undefined;
interface IOptions {
    method?: MethodType;
    headers?: any;
    contentType?: MimeType;
    dataType?: MimeType;
    data?: any;
    timeout?: number;
}
export interface IResponse extends http.IncomingMessage {
    status: number;
    data: Buffer | string | any;
}
export declare function makeHttpRequest(url: string, options?: IOptions): Promise<IResponse>;
/**
 * A simple http client
 */
export declare class HttpClient {
    readonly defaultOptions: Pick<IOptions, 'headers' | 'timeout' | 'method'>;
    constructor(defaultOptions?: Pick<IOptions, 'headers' | 'timeout' | 'method'>);
    request(url: string, options?: IOptions): Promise<IResponse>;
}
export {};
//# sourceMappingURL=httpclient.d.ts.map